// Dialog Tools
// (c) FiveWin IDE

#include "FiveWin.ch"

#define SM_CXBORDER  5
#define SY_CAPTION   4

static nGridX := 8, nGridY := 8

//----------------------------------------------------------------------------//

function DlgNew()

   DlgOpen( cGetNewFileName( "dialogs\DIALOG", "scr" ) )

return nil

//----------------------------------------------------------------------------//

function DlgOpen( cDlgName )

   local oWndDlg, oIco, oBar, oBmp
   local cAlias

   DEFAULT cDlgName := cGetFile( "FiveWin IDE Dialog ( *.scr ) | *.scr",;
                                 "Select a Dialog",, "Dialogs" )

   if Empty( cDlgName )
      MsgInfo( "I can't find that file!" )
      return nil
   endif

   DEFINE ICON oIco RESOURCE "Dialog"

   if File( cDlgName )
      USE ( cDlgName ) NEW SHARED
      cAlias = Alias()

      if RecCount() > 0
         DEFINE WINDOW oWndDlg PIXEL ;
            FROM ( cAlias )->Top, ( cAlias )->Left TO ;
                 ( cAlias )->Top  + ( cAlias )->Height - 1,;
                 ( cAlias )->Left + ( cAlias )->Width - 1 ;
            TITLE "Dialog: " + cNoExt( cNoPath( cDlgName ) ) ;
            COLOR ( cAlias )->ClrFore, ( cAlias )->ClrBack MDICHILD ;
            ICON oIco
      endif
   else
      DEFINE WINDOW oWndDlg FROM 2, 15 TO 20, 65 ;
         TITLE "Dialog: " + cNoExt( cNoPath( cDlgName ) ) MDICHILD ;
         ICON oIco
   endif

   oWndDlg:bPainted = { | hDC, cPS | DrawGrid( hDC, cPS, nGridX, nGridY ) }

   DEFINE BUTTONBAR oBar 3D SIZE 33, 33 OF oWndDlg

   oBar:Hide()

   DEFINE BUTTON OF oBar RESOURCE "Static" ;
      ACTION LabelAdd( oWndDlg, .t., cAlias )

   DEFINE BUTTON OF oBar RESOURCE "Btn1" ;
      ACTION BtnAdd( oWndDlg, .t., cAlias )

   DEFINE BUTTON OF oBar RESOURCE "Check" ;
      ACTION CheckAdd( oWndDlg, .t., cAlias )

   DEFINE BUTTON OF oBar RESOURCE "ListBox" ;
      ACTION LbxAdd( oWndDlg, .t., cAlias )

   DEFINE BUTTON OF oBar RESOURCE "Get" ;
      ACTION GetAdd( oWndDlg, .t., cAlias )

   DEFINE BUTTON OF oBar RESOURCE "Radio" ;
      ACTION RadioAdd( oWndDlg, .t., cAlias )

   DEFINE BUTTON OF oBar RESOURCE "Shade" ;
      ACTION ShadeAdd( oWndDlg, .t., cAlias )

   DEFINE BUTTON OF oBar RESOURCE "Browse" ;
      ACTION BrwAdd( oWndDlg, .t., cAlias )

   DEFINE BUTTON OF oBar RESOURCE "Bitmap"

   DEFINE BUTTON GROUP OF oBar RESOURCE "Clr" ;
      ACTION oWndDlg:SelColor()

   DEFINE BUTTON OF oBar RESOURCE "PRG" ;
      ACTION ( oWndDlg:cGenPRG( "Dlg.prg" ),;
               PrgOpen( "Dlg.prg", GetMruPrgs() ) )

   DEFINE BUTTON GROUP OF oBar RESOURCE "ToDisk" ;
      ACTION lDlgSave( oWndDlg, cDlgName )

   DEFINE BUTTON OF oBar RESOURCE "Exec" ;
      ACTION DlgTest( oWndDlg, cDlgName ) ;
      MESSAGE "Test this Dialog"

   if ! Empty( cAlias )
      while ! EoF()
         do case
            case AllTrim( ( cAlias )->Control ) == "TSAY"
                 LabelAdd( oWndDlg, .f., cAlias )

            case AllTrim( ( cAlias )->Control ) == "TBUTTON"
                 BtnAdd( oWndDlg, .f., cAlias )

            case AllTrim( ( cAlias )->Control ) == "TGET"
                 GetAdd( oWndDlg, .f., cAlias )

            case AllTrim( ( cAlias )->Control ) == "TCHECKBOX"
                 CheckAdd( oWndDlg, .f., cAlias )

            case AllTrim( ( cAlias )->Control ) == "TLISTBOX"
                 LbxAdd( oWndDlg, .f., cAlias )

            case AllTrim( ( cAlias )->Control ) == "TWBROWSE"
                 BrwAdd( oWndDlg, .f., cAlias )
         endcase
         SKIP
      end
      USE
   endif

   ACTIVATE WINDOW oWndDlg ;
      ON INIT oBar:Float() ;
      VALID lDlgSave( oWndDlg, cDlgName )

return nil

//----------------------------------------------------------------------------//

function LabelAdd( oWnd, lNew, cAlias )

   local oSay
   local cLabel

   DEFAULT lNew := .t.

   if lNew
      @ 2, 2 SAY oSay PROMPT "&Label" DESIGN SIZE 70, 28 OF oWnd
   else
      cLabel = AllTrim( ( cAlias )->Caption )
      @ ( cAlias )->Top, ( cAlias )->Left SAY oSay PROMPT cLabel ;
         DESIGN SIZE ( cAlias )->Width, ( cAlias )->Height PIXEL OF oWnd ;
         COLOR ( cAlias )->ClrFore, ( cAlias )->ClrBack ;
         FONT BuildFont( cAlias )
   endif

   oSay:bRClicked = { || ThisInspect( oSay ) }

return nil

//----------------------------------------------------------------------------//

static function BtnAdd( oWnd, lNew, cAlias )

   local oBtn

   if lNew
      @ 2, 2 BUTTON oBtn PROMPT "&Button" SIZE 80, 27 DESIGN OF oWnd
   else
      @ ( cAlias )->Top, ( cAlias )->Left BUTTON oBtn ;
         PROMPT AllTrim( ( cAlias )->Caption ) ;
         DESIGN SIZE ( cAlias )->Width, ( cAlias )->Height PIXEL OF oWnd ;
         FONT BuildFont( cAlias )
   endif

   oBtn:bRClicked = { || ThisInspect( oBtn ) }

return nil

//----------------------------------------------------------------------------//

static function CheckAdd( oWnd, lNew, cAlias )

   local oCheck
   local lStatus := .f.

   if lNew
      @ 2, 2 CHECKBOX oCheck VAR lStatus PROMPT "&CheckBox" ;
         SIZE 115, 24 DESIGN OF oWnd
   else
      @ ( cAlias )->Top, ( cAlias )->Left CHECKBOX oCheck ;
         VAR lStatus PROMPT AllTrim( ( cAlias )->Caption ) ;
         DESIGN SIZE ( cAlias )->Width, ( cAlias )->Height PIXEL OF oWnd ;
         COLOR ( cAlias )->ClrFore, ( cAlias )->ClrBack ;
         FONT BuildFont( cAlias )
   endif

   oCheck:Set3DLook()

   oCheck:bRClicked = { || ThisInspect( oCheck ) }

return oCheck

//----------------------------------------------------------------------------//

static function LbxAdd( oWnd, lNew, cAlias )

   local oLbx
   local cItem := "One"

   if lNew
      @ 2, 2 LISTBOX oLbx VAR cItem ITEMS { "One", "Two", "Three" } ;
        SIZE 100, 100 DESIGN OF oWnd
   else
      @ ( cAlias )->Top, ( cAlias )->Left LISTBOX oLbx VAR cItem ;
         ITEMS { "One", "Two", "Three", "", "", "" } ;
         SIZE ( cAlias )->Width, ( cAlias )->Height PIXEL DESIGN OF oWnd ;
         COLOR ( cAlias )->ClrFore, ( cAlias )->ClrBack ;
         FONT BuildFont( cAlias )
   endif

   oLbx:Set3DLook()
   oLbx:bRClicked = { || ThisInspect( oLbx ) }

return oLbx

//----------------------------------------------------------------------------//

static function GetAdd( oWnd, lNew, cAlias )

   local oGet
   local cItem := Space( 15 )

   if lNew
      @ 2, 2 GET oGet VAR cItem SIZE 115, 24 DESIGN OF oWnd
   else
      @ ( cAlias )->Top, ( cAlias )->Left GET oGet VAR cItem ;
         SIZE ( cAlias )->Width, ( cAlias )->Height PIXEL DESIGN OF oWnd ;
         COLOR ( cAlias )->ClrFore, ( cAlias )->ClrBack ;
         FONT BuildFont( cAlias )
   endif

   oGet:Set3DLook()
   oGet:bRClicked = { || ThisInspect( oGet ) }

return oGet

//----------------------------------------------------------------------------//

static function RadioAdd( oWnd, lNew, cAlias )

   local nItem := 1
   local oRadio

   @ 2, 2 RADIO oRadio VAR nItem PROMPT "&One", "Two", "&Three" OF oWnd

   oRadio:Set3DLook()

   // oRadio:bRClicked = { || ThisInspect( oRadio ) }

return oRadio

//----------------------------------------------------------------------------//

static function ShadeAdd( oWnd, lNew, cAlias )

   local nItem := 1
   local oRadio

   // @ 2, 2 SAY oRadio VAR nItem PROMPT "&One", "Two", "&Three" OF oWnd

   // oRadio:Set3DLook()

   // oRadio:bRClicked = { || ThisInspect( oRadio ) }

return oRadio

//----------------------------------------------------------------------------//

static function BrwAdd( oWnd, lNew, cAlias )

   local oLbx

   if lNew
      @ 2, 2 LISTBOX oLbx FIELDS "" OF oWnd ;
         SIZE 200, 200 ;
         HEADERS "Browse" ;
         DESIGN
   else
      @ ( cAlias )->Top, ( cAlias )->Left LISTBOX oLbx FIELDS "" ;
         SIZE ( cAlias )->Width, ( cAlias )->Height PIXEL DESIGN OF oWnd ;
         COLOR ( cAlias )->ClrFore, ( cAlias )->ClrBack ;
         FONT BuildFont( cAlias )
   endif

   oLbx:bRClicked = { || ThisInspect( oLbx ) }

return oLbx

//----------------------------------------------------------------------------//

static function lDlgSave( oWnd, cDlgName )

   local n
   local aPoint, aControls := oWnd:aControls
   local cAlias

   if ! MsgYesNo( "Do you wish to save this Dialog ?" )
      return .t.
   endif

   if File( cDlgName )
      if ! MsgYesno( "A file with that name already exists." + ;
                     "Do you want to overwrite it ?" )
         return .t.
      endif
   endif

   DbCreate( cDlgName, { { "CONTROL",  "C", 15, 0 },;
                         { "CAPTION",  "C", 40, 0 },;
                         { "ID",       "N",  4, 0 },;
                         { "TOP",      "N",  4, 0 },;
                         { "LEFT",     "N",  4, 0 },;
                         { "WIDTH",    "N",  4, 0 },;
                         { "HEIGHT",   "N",  4, 0 },;
                         { "STYLE",    "N", 15, 0 },;
                         { "CLRFORE",  "N",  8, 0 },;
                         { "CLRBACK",  "N",  8, 0 },;
                         { "FNTNAME",  "C", 15, 0 },;
                         { "FNTWIDTH", "N",  4, 0 },;
                         { "FNTHEIGHT","N",  4, 0 },;
                         { "FNTBOLD",  "L",  1, 0 },;
                         { "FNTITALIC","L",  1, 0 } } )
   USE ( cDlgName ) NEW
   ZAP
   cAlias = Alias()

   oWnd:CoorsUpdate()

   APPEND BLANK
   ( cAlias )->Control = "TDIALOG"
   ( cAlias )->Caption = oWnd:cTitle
   ( cAlias )->Top     = oWnd:nTop
   ( cAlias )->Left    = oWnd:nLeft
   ( cAlias )->Width   = oWnd:nRight - oWnd:nLeft
   ( cAlias )->Height  = oWnd:nBottom - oWnd:nTop
   ( cAlias )->Style   = nValToN( oWnd:nStyle )
   ( cAlias )->ClrFore = oWnd:nClrText
   ( cAlias )->ClrBack = oWnd:nClrPane

   if aControls != nil
      for n = 1 to Len( aControls )
         aControls[ n ]:CoorsUpdate()

         APPEND BLANK
         ( cAlias )->Control   = aControls[ n ]:ClassName()
         ( cAlias )->Caption   = aControls[ n ]:cCaption
         ( cAlias )->Top       = aControls[ n ]:nTop
         ( cAlias )->Left      = aControls[ n ]:nLeft
         ( cAlias )->Width     = aControls[ n ]:nRight - aControls[ n ]:nLeft - 1
         ( cAlias )->Height    = aControls[ n ]:nBottom - aControls[ n ]:nTop - 1
         ( cAlias )->Style     = nValToN( aControls[ n ]:nStyle )
         ( cAlias )->ClrFore   = nValToN( aControls[ n ]:nClrText )
         ( cAlias )->ClrBack   = nValToN( aControls[ n ]:nClrPane )
         if aControls[ n ]:oFont != nil
            ( cAlias )->FntName   = cValToChar( aControls[ n ]:oFont:cFaceName )
            ( cAlias )->FntWidth  = nValToN( aControls[ n ]:oFont:nWidth )
            ( cAlias )->FntHeight = nValToN( aControls[ n ]:oFont:nHeight )
            ( cAlias )->FntBold   = lValToL( aControls[ n ]:oFont:lBold )
            ( cAlias )->FntItalic = lValToL( aControls[ n ]:oFont:lItalic )
         endif
      next
   endif
   USE

return .t.    // Close the Window

//----------------------------------------------------------------------------//

static function nValToN( uVal ) ; return If( ValType( uVal ) != "N", 0, uVal )
static function lValToL( uVal ) ; return If( ValType( uVal ) != "L", .f., uVal )

//----------------------------------------------------------------------------//

static function BuildFont( cAlias )

   local oFont

   if ! Empty( ( cAlias )->FntName )
      oFont = TFont():New( AllTrim( ( cAlias )->FntName ),;
                           ( cAlias )->FntWidth,;
                           ( cAlias )->FntHeight,;
                           .f., ( cAlias )->FntBold,,,,;
                           ( cAlias )->FntItalic )
   endif

return oFont

//----------------------------------------------------------------------------//

static function DlgTest( oWnd, cDlgName )

   local oDlg, aPoint := { 0, 0 }

   oWnd:CoorsUpdate()
   ClientToScreen( oWnd:hWnd, aPoint )

   DEFINE DIALOG oDlg OF oWnd ;
      TITLE cDlgName ;
      FROM oWnd:nTop, oWnd:nLeft TO ;
           oWnd:nBottom - 30, oWnd:nRight - 12 PIXEL

   @ 2, 2 BUTTON "&Ok" OF oDlg

   ACTIVATE DIALOG oDlg ;
      ON INIT oDlg:Move( aPoint[ 1 ] - GetSysMetrics( 4 ) - ;
                         GetSysMetrics( 33 ) + 1,;
                         aPoint[ 2 ] - GetSysMetrics( 32 ) )

return nil

//----------------------------------------------------------------------------//
