#include "FiveWin.ch"
#include "Ide.ch"

#define IT_UNDEFINED 0
#define IT_BITMAP    1
#define IT_DATABASE  2
#define IT_DIALOG    3
#define IT_DOC       4
#define IT_ICON      5
#define IT_INDEX     6
#define IT_LIBRARY   7
#define IT_MENU      8
#define IT_PROGRAM   9
#define IT_REPORT   10
#define IT_SOUND    11

static oWnd, oItemAreas, oIcon

static cIncPath, cLibPath, cProject, lWorkAreas

static aPrjBmps := {}, aObjBmps := {}, aRptBmps := {}

static oMruPrgs, oMruDbfs, oMruPrjs

//----------------------------------------------------------------------------//

function Main()

   local oBar, oDlg, oTmr

   extern IDE_DRIVERS

   MsgLogo( "..\bitmaps\Fw.bmp" )

   DEFINE ICON oIcon RESOURCE "FwIde"

   DEFINE WINDOW oWnd FROM 0, 0 TO 23, 78 ;
      TITLE FWVERSION + " - IDE" ;
      ICON  oIcon ;
      MDI ;
      MENU BuildMenu() ;
      MENUINFO 5                   // Where Windows will report of MdiChild
      
   DEFINE BUTTONBAR oBar 3D SIZE 33, 33 OF oWnd

   DEFINE BUTTON RESOURCE "Info" OF oBar ;
      MESSAGE "About FiveWin" ;
      TOOLTIP "Info" ;
      ACTION ShellAbout( FWVERSION + " IDE", FWCOPYRIGHT, oIcon:hIcon )

   DEFINE BUTTON RESOURCE "SelFile" OF oBar ;
      TOOLTIP "Open a file" ;
      MESSAGE "Select a file" ACTION SelFile()

   DEFINE BUTTON RESOURCE "Exit" OF oBar ACTION oWnd:End() ;
      TOOLTIP "End this app" ;
      MESSAGE "Exit from IDE"

   DEFINE BUTTON RESOURCE "Cut" OF oBar GROUP ;
      TOOLTIP "Cut to clipboard" ;
      MESSAGE "Cut to Clipboard" ACTION MsgInfo( "Cut" )

   DEFINE BUTTON RESOURCE "Copy" OF oBar ;
      TOOLTIP "Copy to clipboard" ;
      MESSAGE "Copy to Clipboard" ACTION MsgInfo( "Copy" )

   DEFINE BUTTON RESOURCE "Paste" OF oBar ;
      TOOLTIP "Paste from clipboard" ;
      MESSAGE "Paste from Clipboard" ACTION MsgInfo( "Paste" )

   DEFINE BUTTON RESOURCE "Project" GROUP OF oBar ;
      TOOLTIP "Open a project" ;
      MESSAGE "Open a project" ACTION PrjOpen( , oMruPrjs )

   DEFINE BUTTON RESOURCE "Debug" OF oBar ;
      MESSAGE "Inspects the application Stack" ACTION StackInspect()

   DEFINE BUTTON RESOURCE "Objects" OF oBar ;
      MESSAGE "Inspects the IDE Object" ACTION ObjInspect( oWnd, "oWnd" )

   DEFINE BUTTON RESOURCE "DataBase" GROUP OF oBar ;
      TOOLTIP "Browse DataBase" ;
      MESSAGE "Use a database" ;
      ACTION DbfOpen(,, oMruDbfs )

   DEFINE BUTTON RESOURCE "Edit" OF oBar ;
      TOOLTIP "Edit a Program" ;
      MESSAGE "Review a program" ACTION PrgOpen(, oMruPrgs )

   DEFINE BUTTON RESOURCE "Menu" OF oBar ;
      TOOLTIP "Open a Menu" ;
      MESSAGE "Review a menu" ACTION MnuOpen()

   DEFINE BUTTON RESOURCE "Dialog" OF oBar ;
      TOOLTIP "Open a Dialog" ;
      MESSAGE "Review a dialog Box" ACTION DlgOpen()

   DEFINE BUTTON RESOURCE "Report" OF oBar ;
      MESSAGE "Review a report" ACTION ReportOpen()

   DEFINE BUTTON RESOURCE "Doc" OF oBar ;
      TOOLTIP "Open documentation" ;
      MESSAGE "Review documentation files" ACTION DocOpen()

   DEFINE BUTTON RESOURCE "Trash" GROUP OF oBar ;
      TOOLTIP "Deleted files" ;
      MESSAGE "Control of deleted objects"

   DEFINE BUTTON RESOURCE "MsDos" GROUP OF oBar ;
      TOOLTIP "Quick MsDos" ;
      MESSAGE "Quick access to MsDos" ;
      ACTION WinExec( "Command.com" )

   // @ 2, 2 BITMAP RESOURCE "Fw16" NOBORDER OF oWnd:oWndClient

   SET MESSAGE OF oWnd TO FWVERSION + " - " + FWCOPYRIGHT CENTERED ;
      DATE CLOCK KEYBOARD

   ACTIVATE WINDOW oWnd MAXIMIZED ;
      ON INIT ( If( lWorkAreas, WorkAreas(),),;
                If( ! Empty( cProject ), PrjOpen( cProject, oMruPrjs ),) ) ;
      ON RIGHT CLICK IdePopup() ;
      VALID MsgYesNo( "Exit FiveWin IDE ?" )

return nil

//----------------------------------------------------------------------------//

function BuildMenu()

   local oMenu

   MENU oMenu
      MENUITEM "&Program"
      MENU
        MENUITEM "&New..."   ACTION PrgNew( oMruPrgs ) MESSAGE "Creates a new program"
        MENUITEM "&Open..."  ACTION PrgOpen(, oMruPrgs ) MESSAGE "Edit a previous program"
        MENUITEM "&Save..."
        MENUITEM "&Save as..."

        SEPARATOR
        MENUITEM "&Execute..." MESSAGE "Execute a program" ACTION Execute()

        SEPARATOR

        MENUITEM "&Print" MESSAGE "Print the current window contents"
        MENUITEM "Printer S&etup" MESSAGE "Setup the printer" ;
           ACTION PrinterSetup()

        SEPARATOR

        MENUITEM "&Exit..." ACTION oWnd:End() ;
          MESSAGE "Finishing with FiveWin IDE"

        MRU oMruPrgs INI ".\Ide.ini" SECTION "MRU-Programs" ;
           MESSAGE "Open this Program" ACTION PrgOpen( cMruItem, oMruPrgs )

      ENDMENU

      MENUITEM "&DataBases"
      MENU
         MENUITEM "&Use DBF..." ACTION DbfOpen(,, oMruDbfs ) ;
            MESSAGE "Open a DataBase"

         MENUITEM "&Create DBF..."  ACTION DbfNew( oMruDbfs ) ;
            MESSAGE "Create a new DataBase"

         MENUITEM oItemAreas PROMPT "&WorkAreas..." ;
            ACTION WorkAreas( oItemAreas ) ;
            MESSAGE "Inspects the DataBase WorkAreas"

         MENUITEM "&Dictionaries" ;
            MESSAGE "Application Dictionaries management" ;
            ACTION  DictOpen()

         SEPARATOR
         MENUITEM "I&ndexes..."  ACTION Indexes() ;
            MESSAGE "Inspects the database indexes"

         MENUITEM "&Relations..." ;
            MESSAGE "Inspects the database relations" ;
            ACTION Relations( Alias() )

         MENUITEM "&Filters..."   MESSAGE "Controls of existing filters"
         SEPARATOR

         MENUITEM "New r&eport..." ACTION ReportNew() ;
            MESSAGE "Design a new report"

         MRU oMruDbfs INI ".\ide.ini" SECTION "MRU-DataBases" ;
            MESSAGE "Browse this DataBase" ;
            ACTION DbfOpen( cMruItem,, oMruDbfs )

      ENDMENU

      MENUITEM "&Resources"
      MENU
         MENUITEM "&Bitmaps" ACTION BmpOpen() MESSAGE "Review a bitmap"
         MENUITEM "&Dialog Boxes..."  ACTION DlgNew() ;
            MESSAGE "Create a new Dialog Box"

         MENUITEM "&Icons..." ACTION IconOpen() ;
            MESSAGE "Review Icons"

         MENUITEM "&PullDown Menu..."
         MENUITEM "&Sound..."         ACTION WinExec( "SoundRec" )

         MENUITEM "&Text..."  ACTION TxtOpen() ;
            MESSAGE "Review a text file"

         MENUITEM "&Video..."
         SEPARATOR
         MENUITEM "&Compile RC... " ;
            ACTION WinExec( "pifs\rc.pif" + ;
                            cGetFile( "Windows Resources (*.rc) | *.rc",;
                                      "Select a RC" ) )
         MENUITEM "&Resource WorkShop" ;
            ACTION WinExec( "c:\borlandc\bin\WorkShop" ) ;
            MESSAGE "Use Borland's Resource WorkShop"
      ENDMENU

      MENUITEM "Pr&oject"
      MENU
         MENUITEM "&New Project..." ACTION PrjNew( oMruPrjs ) ;
            MESSAGE "Creates a new project"

         MENUITEM "&Open Project..." ACTION PrjOpen(, oMruPrjs ) ;
            MESSAGE "Use a previous defined project"

         SEPARATOR
         MENUITEM "&Create documentation..." ;
            MESSAGE "Build new documentation files" ACTION DocNew()

         MENUITEM "&Review Libraries..." ;
            MESSAGE "Review Libraries LIB files"

         SEPARATOR
         MENUITEM "&Configure..." ACTION PrjConfig() ;
            MESSAGE "Set default Project parameters"

         MENUITEM "&Build"
         SEPARATOR

         MENUITEM "&FiveWin RegisterEXE()" ;
            MESSAGE "Free a FiveWin application" ;
            ACTION RegisterEXE()

         MRU oMruPrjs INI ".\ide.ini" SECTION "MRU-Projects" ;
            MESSAGE "Open this project" ACTION PrjOpen( cMruItem, oMruPrjs )

      ENDMENU

      oMenu:AddMdi()
      oMenu:AddHelp( "FiveWin IDE", "(c) FiveTech" )

   ENDMENU

return oMenu

//----------------------------------------------------------------------------//

init procedure IdeInit()

   local oIni

   SET RESOURCES TO "Ide.dll"
   SET 3DLOOK ON

   RddSetDefault( "DbfNtx" )

   INI oIni FILENAME "\" + CurDir() + "\Ide.ini"

      GET cIncPath SECTION "Path" ENTRY "Include" ;
         DEFAULT "c:\clipper5\include" OF oIni

      GET cLibPath SECTION "Path" ENTRY "Lib" ;
         DEFAULT "c:\clipper5\lib" OF oIni

      GET cProject SECTION "Project" ENTRY "Name" ;
         DEFAULT "" OF oIni

      GET lWorkAreas SECTION "Project" ENTRY "WorkAreas" ;
         DEFAULT .f. OF oIni

   ENDINI

   aPrjBmps = { LoadBitmap( GetResources(), "QesSmal" ),;
                LoadBitmap( GetResources(), "BmpSmal" ),;
                LoadBitmap( GetResources(), "DbfSmal" ),;
                LoadBitmap( GetResources(), "DlgSmal" ),;
                LoadBitmap( GetResources(), "DocSmal" ),;
                LoadBitmap( GetResources(), "IcoSmal" ),;
                LoadBitmap( GetResources(), "IdxSmal" ),;
                LoadBitmap( GetResources(), "LibSmal" ),;
                LoadBitmap( GetResources(), "MnuSmal" ),;
                LoadBitmap( GetResources(), "PrgSmal" ),;
                LoadBitmap( GetResources(), "RptSmal" ),;
                LoadBitmap( GetResources(), "SndSmal" ) }

   aObjBmps = { LoadBitmap( GetResources(), "Array" ),;
                LoadBitmap( GetResources(), "Block" ),;
                LoadBitmap( GetResources(), "Chain" ),;
                LoadBitmap( GetResources(), "Date" ),;
                LoadBitmap( GetResources(), "Logic" ),;
                LoadBitmap( GetResources(), "Number" ),;
                LoadBitmap( GetResources(), "Memo" ),;
                LoadBitmap( GetResources(), "Object" ),;
                LoadBitmap( GetResources(), "Undefined" ),;
                LoadBitmap( GetResources(), "SmallBug" ),;
                LoadBitmap( GetResources(), "NoInfo" ) }

   aRptBmps = { LoadBitmap( GetResources(), "Header" ),;
                LoadBitmap( GetResources(), "Body" ),;
                LoadBitmap( GetResources(), "Footer" ) }

return

//----------------------------------------------------------------------------//

exit procedure IdeExit()

   AEval( aPrjBmps, { | hBmp | DeleteObject( hBmp ) } )
   AEval( aObjBmps, { | hBmp | DeleteObject( hBmp ) } )
   AEval( aRptBmps, { | hBmp | DeleteObject( hBmp ) } )

return

//----------------------------------------------------------------------------//

function ItemOpen( oBrw )

   local nType     := ( oBrw:cAlias )->Type
   local cFileName := ( oBrw:cAlias )->Name

   if nType != 0 .and. ! File( cFileName )
      MsgAlert( "I can't find that file!" )
      return nil
   endif

   do case
      case nType == IT_UNDEFINED
           ItemNew( oBrw )

      case nType == IT_BITMAP
           BmpOpen( cFileName )

      case nType == IT_DIALOG
           DlgOpen( cFileName )

      case nType == IT_DOC
           DocOpen( cFileName )

      case nType == IT_LIBRARY
           LibOpen( cFileName )

      case nType == IT_MENU
           MnuOpen( cFileName )

      case nType == IT_DATABASE
           DbfOpen( cFileName,, oMruDbfs )

      case nType == IT_PROGRAM
           PrgOpen( cFileName, oMruPrgs )

      case nType == IT_SOUND
           WinExec( "SoundRec " + cFileName )

      case nType == IT_REPORT
           ReportOpen( cFileName )

      case nType == IT_ICON
           IconOpen( cFileName )
   endcase

return nil

//----------------------------------------------------------------------------//

function ItemNew( oBrw )

   local oDlg, oGet
   local cFile := PadR( ( oBrw:cAlias )->Name, 50 )
   local cDescript := PadR( ( oBrw:cAlias )->Descript, 50 )
   local aItems := { "Bitmap", "DataBase", "Dialog", "Documentation",;
                     "Icon", "Index", "Library", "Menu", "Program",;
                     "Report", "Sound" }
   local cType := aItems[ Min( Max( ( oBrw:cAlias )->Type, 1 ), Len( aItems ) ) ]

   DEFINE DIALOG oDlg RESOURCE "PrjItem"

   REDEFINE GET oGet VAR cFile ID 110 OF oDlg

   REDEFINE COMBOBOX cType ITEMS aItems ;
     ID 120 OF oDlg

   REDEFINE GET cDescript ID 130 OF oDlg

   REDEFINE BUTTON ID 140 OF oDlg ;
      ACTION ( cFile := cGetIdeFile( AScan( aItems, cType ) ),;
               oGet:Refresh() )

   ACTIVATE DIALOG oDlg

   if oDlg:nResult == IDOK
      if ( oBrw:cAlias )->( RLock() )
         ( oBrw:cAlias )->Type     := If( ! Empty( cFile ),;
                                          AScan( aItems, cType ), 0 )
         ( oBrw:cAlias )->Name     := cFile
         ( oBrw:cAlias )->Descript := cDescript
         oBrw:UpStable()
         oBrw:Refresh()
         ( oBrw:cAlias )->( DbUnLock() )
      else
         MsgAlert( "DataBase in Net use! Unable to perform the operation" )
      endif
   endif

return nil

//----------------------------------------------------------------------------//

function ItemDel( oBrw )

   if MsgYesNo( "Do you want to delete the current item ?" )
      if ( oBrw:cAlias )->( RLock() )
         ( oBrw:cAlias )->( DbDelete() )
         // ( oBrw:cAlias )->( DbPack() )
         ( oBrw:cAlias )->( DbUnLock() )
         oBrw:Refresh()
      endif
   endif

return nil

//----------------------------------------------------------------------------//

function cNoPath( cFileName )

return SubStr( cFileName, RAt( "\", cFileName ) + 1 )

//----------------------------------------------------------------------------//

function cNoExt( cFileName )

return SubStr( cFileName, 1, RAt( ".", cFileName ) - 1 )

//----------------------------------------------------------------------------//

function SelFile()

   local cExt
   local cFile := cGetIdeFile()

   if ! Empty( cFile )

      cExt = SubStr( cFile, RAt( ".", cFile ) + 1 )

      do case
         case cExt == "PRG"
              PrgOpen( cFile, oMruPrgs )

         case cExt == "BMP"
              BmpOpen( cFile )

         case cExt == "DBF"
              DbfOpen( cFile,, oMruDbfs )

         case cExt == "SCR"
              DlgOpen( cFile )

         case cExt == "DOC"
              DocOpen( cFile )

         case cExt == "ICO"

         case cExt == "IDX"

         case cExt == "LIB"
              LibOpen( cFile )

         case cExt == "MNU"
              MnuOpen( cFile )

         case cExt == "RPT"
              ReportOpen( cFile )

         case cExt == "WAV"
              WinExec( "SoundRec " + cFile )
      endcase
   endif

return nil

//----------------------------------------------------------------------------//

function cGetIdeFile( nFilter )

return cGetFile( "Windows Bitmap (*.bmp) | *.bmp |" + ;
                 "DataBase (*.dbf) | *.dbf |" + ;
                 "FiveWin Dialog (*.scr) | *.scr |" + ;
                 "FiveWin Documentation (*.doc) | *.doc |" + ;
                 "Windows Icon (*.ico) | *.ico |" + ;
                 "FiveWin Index (*.idx) | *.idx |" + ;
                 "Library file (*.lib) | *.lib |" + ;
                 "FiveWin Menu (*.mnu) | *.mnu |" + ;
                 "Clipper Program (*.prg) | *.prg |" + ;
                 "FiveWin Report (*.rpt) | *.rpt |" + ;
                 "Windows sound (*.wav) | *.wav",;
                 "Select a File", nFilter )

//----------------------------------------------------------------------------//

function PrjConfig()

   local oDlg, oPrj, oIni
   local cPrj := If( cProject == nil, Space( 40 ), PadR( cProject, 40 ) )
   local cPrg := Space( 20 )

   DEFINE DIALOG oDlg RESOURCE "PrjConfig"

   REDEFINE GET oPrj VAR cPrj ID 110 OF oDlg

   REDEFINE CHECKBOX lWorkAreas ID 120 OF oDlg WHEN ! Empty( cPrj )

   REDEFINE GET cPrg ID 130 OF oDlg

   REDEFINE BUTTON ID 140 OF oDlg ;
      ACTION ( cPrj := cGetFile( "FiveWin Project (*.prj) | *.prj",;
               "Select a Project" ), oPrj:Refresh() )

   ACTIVATE DIALOG oDlg CENTERED ;
      ON RIGHT CLICK ThisInspect( oDlg )

   if oDlg:nResult == IDOK
      INI oIni FILENAME "\" + CurDir() + "\Ide.ini"
          SET SECTION "Project" ENTRY "WorkAreas" OF oIni TO lWorkAreas
          SET SECTION "Project" ENTRY "Name"      OF oIni TO cPrj
      ENDINI
      cProject = cPrj
   endif

return nil

//----------------------------------------------------------------------------//

function GetIndexKey( nArea )

return If( ! Empty( Alias( nArea ) ),;
       If( ( nArea )->( IndexOrd() ) != 0, "Yes", "No" ), Space( 30 ) )

//----------------------------------------------------------------------------//

function GetRddName( nArea )

return If( ! Empty( Alias( nArea ) ), ( nArea )->( RddName() ), Space( 30 ) )

//----------------------------------------------------------------------------//

function BtnInspect( oBtn )

   local oDlg
   local nRow     := oBtn:nTop
   local nCol     := oBtn:nLeft
   local cCaption := oBtn:cCaption

   DEFINE DIALOG oDlg RESOURCE "BtnInspect"

   REDEFINE GET nRow     ID 110 OF oDlg
   REDEFINE GET nCol     ID 120 OF oDlg
   REDEFINE GET cCaption ID 150 OF oDlg

   ACTIVATE DIALOG oDlg CENTERED

return nil

//----------------------------------------------------------------------------//

function DbPack() ; PACK ; return nil

//----------------------------------------------------------------------------//

function RecEdit( cTitle, oBrwParent )

   local oWndRec, oBrw, oIco, oFont
   local cAlias := Alias()
   local nField := 1
   local aInfo  := DbStruct()

   DEFINE ICON oIco RESOURCE "Record"

   DEFINE WINDOW oWndRec FROM 1, 43 TO 23, 79 ;
      TITLE cTitle MDICHILD ;
      ICON oIco

   DEFINE FONT oFont NAME "Arial" SIZE 6, 15 BOLD

   @ 2, 0 LISTBOX oBrw FIELDS "" ;
      HEADERS "", "Field", "Value" ;
      SIZES   16,      95,    400 ;
      SIZE 400, 400 ;
      COLOR oBrwParent:nClrText, oBrwParent:nClrPane ;
      FONT oFont

   oBrw:bLine     = { || ( cAlias )->( FldInfo( nField, aInfo[ nField ][ 2 ] ) ) }
   oBrw:bLogicLen = { || ( cAlias )->( FCount() ) }
   oBrw:bGoTop    = { || nField := 1 }
   oBrw:bGoBottom = { || nField := ( cAlias )->( FCount() ) }
   oBrw:bSkip     = { | nSkip, nOld | nOld := nField, nField += nSkip,;
                  nField := Min( Max( nField, 1 ), ( cAlias )->( FCount() ) ),;
                  nField - nOld }

   oWndRec:SetControl( oBrw )

   ACTIVATE WINDOW oWndRec ;
      VALID ( oWndRec := nil, .t. )            // Destroy the Object

return oWndRec

//----------------------------------------------------------------------------//

static function FldInfo( nField, cType )

   local uData := FieldGet( nField )

return { aObjBmps[ At( cType, "ABCDLNMOU" ) ], Field( nField ),;
         cValToChar( uData ) }

//----------------------------------------------------------------------------//

function GetWndMain()  ; return oWnd       // to export oWnd to other modules
function GetObjBmps()  ; return aObjBmps
function GetPrjBmps()  ; return aPrjBmps
function GetRptBmps()  ; return aRptBmps

//----------------------------------------------------------------------------//

function IdePopup()

   local oMenu

   MENU oMenu POPUP
      MENUITEM "&Configure"
      MENU
         MENUITEM "&Project..." ;
            MESSAGE "Set the default values of the IDE" ;
            ACTION PrjConfig()

         MENUITEM "&Control Panel..." ;
            MESSAGE "Set Windows default values" ;
            ACTION WinExec( "Control" )
      ENDMENU

      MENUITEM "&Inspect..."
      MENU
         MENUITEM "&Object IDE Window" ;
            MESSAGE "Inspect the Object IDE" ;
            ACTION ObjInspect( oWnd, "oWnd" )

         MENUITEM "&Application Stack" ;
            MESSAGE "Inspect the whole application stack" ;
            ACTION  StackInspect()

         MENUITEM "&Windows API activity" ;
            MESSAGE "Inspect the messages sent by Windows" ;
            ACTION  ApiInspect()

         MENUITEM "&Memory available" ;
            MESSAGE "Memory values availables"

         MENUITEM Str( Len( GetAllWin() ) )

      ENDMENU
   ENDMENU

   ACTIVATE POPUP oMenu AT 200, 200 OF oWnd

return nil

//----------------------------------------------------------------------------//

function cGetNewFileName( cName, cExt )

   local cTemp := cName + "01" + "." + cExt
   local nId   := 1

   while File( cTemp )
      cTemp = cName + StrZero( ++nId, 2 ) + "." + cExt
   end

return cTemp

//----------------------------------------------------------------------------//

function Execute()

   local oDlg, oGet
   local cExeName := Space( 30 ), cParams := Space( 30 )

   DEFINE DIALOG oDlg RESOURCE "Execute"

   REDEFINE GET oGet VAR cExeName ID 110 OF oDlg

   REDEFINE GET cParams ID 130 OF oDlg

   REDEFINE BUTTON ID 120 OF oDlg ;
      ACTION ( cExeName := ;
               cGetFile( "*.exe", "Select the application to execute" ),;
               oGet:Refresh() )

   ACTIVATE DIALOG oDlg CENTERED

   if oDlg:nResult == ID_OK
      WinExec( cExeName + " " + cParams )
   endif

return nil

//----------------------------------------------------------------------------//

function GetMruPrgs() ; return oMruPrgs

//----------------------------------------------------------------------------//
