/* _GenError( nType, cClassName, cMethod )

    LLamada desde C para describir los errores en runtime.

    Tipo N       Descripcin del Error.
    ======================================================================
    0             No Hay error. Algun despistado nos llama para ver que pasa.
    1             Error de acceso a Metodo Private.
    2             Error de acceso a InstVar Protected.
    3             Error de acceso a InstVar Private.
    4             Error "Data type error. Type-Protected InstVar. "
    5             Error aadiendo Mtodo: No est lincada la funcin asociada.
    6             Error "No exported Method".
    7             Error "No exported PARENT Method"
    8             Error "You can't send messages to non Objects. "
    9             Error "Bad Parent Msg"
    10            Error "Parent exist"
    11            Error "Already added"
    12            Error "No executable"
    13            Error "No Command Obj."
                  error 11 para cuando se intenta aadir un
                  mtodo con una funcin que ya es mtodo de otra clase.

    Tambin la clase Command podra generar un error 12 cuando se intente
    ejecutar (::exec() ) un objeto command no ejecutable.
    y el mensaje send sin un objeto command generar el error 13, no command
    object send.
*/


// Tipos de ERROR
#define PRIVATE_METHOD     1
#define PROTECTED_INSTVAR  2
#define PRIVATE_INSTVAR    3
#define DATATYPE_INSTVAR   4
#define BAD_CODEBLOCK      5
#define NO_EXPORTED        6
#define PARENT_ERROR       7
#define NO_ES_UN_OBJETO    8
#define BAD_PARENT_MSG     9
#define PARENT_EXIST      10
#define ALREADY_ADD       11
#define NO_EXEC_COMM      12
#define NO_COMMAND_OBJ    13

#define MAX_DEFINED_ERRORS 13
