#include <Winten.h>
#include <Windows.h>
#include <ClipApi.h>
// 
// 
// 
// 
// Bug correction by MCN for the situation when a menu is replaced and an
// existing accelarator key gets a new ID. The accelarator key would not 
// work any more after the menu replacement. This was because a new
// hot-key + ID combination was being added instead of the old entry 
// being replaced with the new ID. Windows would find the old entry instead
// of the added new entry and would retrieve the old (invalid) ID
// In this bug correction the table is first searched for the accelarator.
// If found, the entry is modified, if not found the old behaviour of adding
// a new entry is maintained
// Miguel Oliveira, 9/6/95
// 
// 
// 
// 
extern HGLOBAL   _SetAcceleratorTable( HGLOBAL hAccelTable );
extern HGLOBAL   _fwAddGlobal( HGLOBAL );
extern HGLOBAL   fwGlobalAlloc( WORD, LONG );
extern HGLOBAL   fwGlobalReAlloc( HGLOBAL, LONG, WORD );
extern WORD      GetWndApp( void );

#define CHUNK  6

typedef struct
{
    BYTE bFlags;
    WORD wEvent;
    WORD wId;
} ACCELENTRY;

typedef ACCELENTRY far * LPACCELENTRY;

#define ACC_SHIFT   0x04
#define ACC_CONTROL 0x08
#define ACC_ALT     0x10

static WORD wAccSize  = 0;
static WORD wAccCount = 0;

//---------------------------------------------------------------------------//

WORD wAccelTableLen( LPACCELENTRY pTable )
{
    WORD wIndex = 0;

    while( !( pTable[ wIndex++ ].bFlags & 0x80 ) );

    if( pTable[ wIndex - 1 ].wEvent )
        return wIndex;
    else
        return 0xFFFF;

}

//---------------------------------------------------------------------------//

CLIPPER __AddAccel( void ) // ( nState, nVirtKey, nId )
{

    HGLOBAL hAccel;
    LPACCELENTRY pTable;
	 //---------------- added by MCN --------------------\
    BOOL isPresent = FALSE;
    WORD nKey = _parni(2);
    BYTE state = (BYTE) ( _parni( 1 ) | 0x0001 );
    WORD nIndex = 0;
    WORD nTableIndex = wAccCount;
	 //--------------------------------------------------/
    if( ! wAccSize )
    {
        hAccel = _fwAddGlobal( fwGlobalAlloc( GHND,  CHUNK * sizeof( ACCELENTRY ) ) );
        wAccSize  = CHUNK;
        _SetAcceleratorTable( hAccel );
    }
    else
        hAccel = _SetAcceleratorTable( 0 );


    if( hAccel )
    {    //----------------------Added by MCN-------------------------------\
   	   pTable = (LPACCELENTRY) GlobalLock( hAccel );

         while( nIndex < wAccCount && ! isPresent )
         {
            if  (pTable[nIndex].wEvent == nKey && ( (pTable[nIndex].bFlags & 0x7F) == state))   //|| pTable[nIndex].bFlags == (state | 0x80) ) ) 
            {
               isPresent = TRUE;
            }
            nIndex++;
         }
        
		   GlobalUnlock( hAccel );
         //----------------------Added by MCN------------------------------/
         if( wAccCount == wAccSize && ! isPresent ) //<------- Modif. by MCN
         {
            wAccSize += CHUNK;
            hAccel = fwGlobalReAlloc( hAccel, wAccSize * sizeof( ACCELENTRY ), GHND );
            _SetAcceleratorTable( hAccel );
         }

		   pTable = (LPACCELENTRY) GlobalLock( hAccel );
         //----------------------Added by MCN-------------------------------\
         if ( isPresent )
            nTableIndex = nIndex -1;
         if ( ! isPresent )
         {
         //-----------------------------------------------------------------/
            pTable[ nTableIndex ].bFlags = (BYTE) ( _parni( 1 ) | 0x0001 ); // <-- Modif by MCN
            pTable[ nTableIndex ].wEvent = _parni( 2 );                     // <-- Modif by MCN
         }
         pTable[ nTableIndex ].wId    = _parni( 3 );                        // <-- Modif by MCN  

        // End OF Table
         if( wAccCount && ! isPresent )                                     // <-- Modif by MCN
            pTable[ wAccCount - 1 ].bFlags ^= 0x80;

	 //----------------------Added by MCN-------------------\
         if(! isPresent )
         {
            pTable[ wAccCount ].bFlags |= 0x80;
            wAccCount++;
         }
         //------------------------------------------------------/

	 GlobalUnlock( hAccel );

	}

}
