#include <WinTen.h>
#include <Windows.h>
#include <ClipApi.h>

#define CTL3D_ALL  0xFFFF

BOOL pascal Ctl3dRegister( HANDLE hInstance );
BOOL pascal Ctl3dAutoSubClass( HANDLE hInstance );
BOOL pascal Ctl3dUnregister( HANDLE hInstance );
BOOL pascal Ctl3dSubclassCtl( HWND hCtl );
BOOL pascal Ctl3dSubClassDlgEx( HWND hWnd, DWORD wMode );

extern void _fwAddTerminator( PCLIPFUNC );  // FiveWin internal.

extern HANDLE __hInstance;

static BOOL bInstaled;
static WORD wTimes = 0;

static BYTE bRegisterTerminator = FALSE;

//----------------------------------------------------------------------------//

static CLIPPER UnInstall( void )
{
   if( --wTimes )
      return;

   if( bInstaled )
   {
       Ctl3dUnregister( __hInstance );
       bInstaled = FALSE;
   }
}

//---------------------------------------------------------------------------//

static void CheckTerminator( void )
{
    if( ! bRegisterTerminator )
    {
        bRegisterTerminator = TRUE;
        _fwAddTerminator( UnInstall );
    }
}

//---------------------------------------------------------------------------//

static CLIPPER Install( void )
{
   if( ! bInstaled )
   {
       bInstaled = TRUE;
       Ctl3dRegister( __hInstance );
       Ctl3dAutoSubClass( __hInstance );
       CheckTerminator();
   }
   wTimes++;
}

//---------------------------------------------------------------------------//

CLIPPER Set3DLook()
{
   _retl( bInstaled );

   if( _parl( 1 ) )
   {
       Install();
   }
   else if( PCOUNT() )
   {
       UnInstall();
   }
}

//----------------------------------------------------------------------------//

CLIPPER CTL3DLOOK()   //  hWnd  --> lSuccess     // Makes 3D any Control
{
   Install();

   _retl( Ctl3dSubclassCtl( _parni( 1 ) ) );
}

//----------------------------------------------------------------------------//

CLIPPER CTL3DREGIS() // TER()
{
   Ctl3dRegister( _parni( 1 ) );
}

//----------------------------------------------------------------------------//

CLIPPER CTL3DAUTOS() // UBCLASS()
{
   Ctl3dAutoSubClass( _parni( 1 ) );
}

//----------------------------------------------------------------------------//

CLIPPER CTL3DUNREG() // ISTER()
{
   Ctl3dUnregister( _parni( 1 ) );
}

//----------------------------------------------------------------------------//

CLIPPER CTL3DDLGEX() // hWnd, nType --> lSuccess
{
   _retl( Ctl3dSubClassDlgEx( _parni( 1 ), 
                              IF( _parni( 2 ), _parni( 2 ), CTL3D_ALL ) ) );
}

//----------------------------------------------------------------------------//

