#include <WinTen.h>
#include <Windows.h>
#include <ClipApi.h>

#define FW_MEASURE  WM_USER+1031
#define FW_DRAW     WM_USER+1032

WORD strlen( LPSTR );

void DrawMasked( HDC, HBITMAP, WORD, WORD );
void DrawBitmap( HDC, HBITMAP, WORD, WORD, WORD, WORD, LONG );

void DrawFrame( HDC hDC, LPRECT pRect );

//----------------------------------------------------------------------------//

CLIPPER CtrlDraw()
{
   DRAWITEMSTRUCT * pDraw = ( DRAWITEMSTRUCT * ) _parnl( 1 );

   _retni( SendMessage( pDraw->hwndItem, FW_DRAW, 0, ( LONG ) pDraw ) );
}

//----------------------------------------------------------------------------//

CLIPPER LbxMeasure()
{
   LPMEASUREITEMSTRUCT pMeasure = ( LPMEASUREITEMSTRUCT ) _parnl( 1 );

   pMeasure->itemHeight = _parni( 2 );

   _retl( TRUE );
}

//----------------------------------------------------------------------------//

CLIPPER LbxDrawIte() // m( LPDRAWITEMSTRUCT lp, aBitmaps, aItems, nBmpWidth,
                     //    bDrawItem ) --> .t.
{
   LPDRAWITEMSTRUCT lp = ( LPDRAWITEMSTRUCT ) _parnl( 1 );
   RECT rct;
   COLORREF rgbFore, rgbBack;
   WORD wItems = _VARRAYLEN( _param( 2, ARRAY ) );
   BYTE szName[ 30 ];
   HWND hWnd;
   HDC hDC;

   if( lp->itemID == -1 )
   {
      DrawFocusRect( lp->hDC, &lp->rcItem );
      _retl( TRUE );
      return;
   }
   else
   {
      switch( lp->itemAction )
      {
         case ODA_DRAWENTIRE:
         case ODA_SELECT:
              if( lp->itemState & ODS_FOCUS )
                 DrawFocusRect( lp->hDC, &lp->rcItem );

              rct.top    = lp->rcItem.top;
              rct.left   = lp->rcItem.left;
              rct.bottom = lp->rcItem.bottom;
              rct.right  = lp->rcItem.right;

              if( lp->itemState & ODS_SELECTED )
              {
                 rgbFore = SetTextColor( lp->hDC, GetSysColor( COLOR_HIGHLIGHTTEXT ) );
                 rgbBack = SetBkColor( lp->hDC, GetSysColor( COLOR_HIGHLIGHT ) );
              }

              ExtTextOut( lp->hDC, rct.left + 3 + _parni( 4 ), rct.top,
                          ETO_CLIPPED | ETO_OPAQUE, &rct,
                          _parc( 3, lp->itemID + 1 ),

                          _parclen( 3, lp->itemID + 1 ), 0 );


              if( ISBLOCK( 5 ) )
              {
                 _retni( lp->itemID + 1 );
                 _cEval1( _param( 5, BLOCK ), _eval );
                 DrawBitmap( lp->hDC, _parni( 2, _parni( -1 ) ),
                             lp->rcItem.top, lp->rcItem.left, 0, 0, 0 );
              }
              else
                 DrawBitmap( lp->hDC, _parni( 2, lp->itemID + 1 ),
                             lp->rcItem.top, lp->rcItem.left, 0, 0, 0 );

              if( lp->itemState & ODS_SELECTED )
              {
                 SetTextColor( lp->hDC, rgbFore );
                 SetBkColor( lp->hDC, rgbBack );
              }
              if( lp->itemState & ODS_FOCUS )
                 DrawFocusRect( lp->hDC, &lp->rcItem );
              break;

         case ODA_FOCUS:
              GetClassName( GetParent( lp->hwndItem ), szName, 30 );
              if( lp->CtlType == ODT_COMBOBOX || szName[ 5 ] != '0' ) // #32770
                 DrawFocusRect( lp->hDC, &lp->rcItem );               // Dialog
              break;
      }
   }
   _retl( TRUE );
}

//----------------------------------------------------------------------------//

CLIPPER CTRLDRAWFO()  // CUS()      hWnd, nOriginRow, nOriginCol
{
   HWND hWnd = _parni( 1 );
   WORD wRow = _parni( 2 );
   WORD wCol = _parni( 3 );
   HWND hWndParent = GetParent( hWnd );
   HDC hDC   = GetDC( hWndParent );
   RECT rct;
   POINT pt;

   GetWindowRect( hWnd, &rct );

   rct.bottom += wRow; // + 1
   rct.right  += wCol; // + 1
   rct.top    += wRow;
   rct.left   += wCol;

   pt.x = rct.left;
   pt.y = rct.top;

   ScreenToClient( hWndParent, &pt );
   rct.left = pt.x - 1;
   rct.top  = pt.y - 1;
   pt.x     = rct.right;
   pt.y     = rct.bottom;

   ScreenToClient( hWndParent, &pt );
   rct.right  = pt.x;
   rct.bottom = pt.y;

   // DrawFocusRect( hDC, &rct );
   DrawFrame( hDC, &rct );

   ReleaseDC( hWndParent, hDC );

}

//----------------------------------------------------------------------------//

void DrawFrame( HDC hDC, LPRECT pRect )
{

    HPEN hPen = GetStockObject( WHITE_PEN );
    HPEN hOld = SelectObject( hDC, hPen );

    int iRop  = SetROP2( hDC, R2_XORPEN );

    MoveTo( hDC, pRect->left, pRect->top );

    LineTo( hDC, pRect->right, pRect->top );
    LineTo( hDC, pRect->right, pRect->bottom );
    LineTo( hDC, pRect->left, pRect->bottom );
    LineTo( hDC, pRect->left, pRect->top );

    SetROP2( hDC, iRop );
    SelectObject( hDC, hOld );
}

//---------------------------------------------------------------------------//
