#include "WinTen.h"
#include <Windows.h>
#include "ddeml.h"
#include "ClipApi.h"
FARPROC        lpDdeProc;              /*  DDE callback function           */


#pragma argsused
HDDEDATA EXPENTRY _export DDECallback ( WORD wType, WORD wFmt, HCONV hConvX, HSZ hsz1,
        HSZ hsz2, HDDEDATA hData, DWORD dwData1,
        DWORD dwData2 )
{
   switch ( wType )
   {
      case XTYP_DISCONNECT:
         // hConv = NULL;
         return ( (HDDEDATA) NULL );

      case XTYP_ERROR:
         break;

      case XTYP_XACT_COMPLETE:
         // compare transaction identifier, indicate transaction complete
         break;

   }

   return ( (HDDEDATA) NULL );
}





CLIPPER DDEML_INIT()
{
   HANDLE         hInst;                  /*  Current instance of application */
   DWORD          idInst = 0L;            /*  Instance of app for DDEML       */
   lpDdeProc = MakeProcInstance ( (FARPROC) DDECallback, hInst );
   if ( DdeInitialize ( (LPDWORD)&idInst, (PFNCALLBACK)lpDdeProc,
                        APPCMD_CLIENTONLY, 0L ) )
   {
      _retnl(-1);
   }
   else
   {
      _retnl(idInst);
   }
}


CLIPPER DDEML_CONN() //ECT(idInst,cservice,cTopic)
{

   HSZ hszService;
   HSZ hszTopic;
   DWORD idInst = _parnl(1);            /*  Instance of app for DDEML       */
   HCONV hConv = NULL;           /*Handle of established conversation*/
   hszService = DdeCreateStringHandle ( idInst, _parc(2), CP_WINANSI );
   hszTopic = DdeCreateStringHandle ( idInst,_parc(3), CP_WINANSI );

   hConv = DdeConnect ( idInst, hszService, hszTopic,
            (PCONVCONTEXT) NULL );

   _retnl(hConv);
}


CLIPPER DDEML_DISC() //CONNECT(hConv)
{
   DdeDisconnect ( _parnl(1) );
   FreeProcInstance ( lpDdeProc );

}

CLIPPER DDEML_POKE() //(idInst, hConv, cItem,cData)
{
   DWORD dwResult;
   HDDEDATA hData;
   HSZ hszItem;
   WORD wFmt = CF_TEXT;         /*  Clipboard format                */

   hszItem = DdeCreateStringHandle ( _parnl(1), _parc(3), CP_WINANSI );

   hData = DdeCreateDataHandle ( _parnl(1), _parc(4),
            _parclen(4), 0L, hszItem, wFmt, 0 );

   hData = DdeClientTransaction ( (LPBYTE)hData, -1, _parnl(2),
             hszItem, wFmt, XTYP_POKE, TIMEOUT_ASYNC, &dwResult );

   _retl(hData);
}



CLIPPER DDEML_EXEC() //(idInst, hConv, cCommand)
{
   DWORD dwResult;
   HDDEDATA hData;
   HSZ hszItem;
   WORD wFmt = CF_TEXT;         /*  Clipboard format                */

   hData = DdeCreateDataHandle ( _parnl(1), _parc(3),
            _parclen(3), 0L, hszItem, wFmt, 0 );

   hData = DdeClientTransaction ( (LPBYTE)hData, -1, _parnl(2),
             hszItem, wFmt, XTYP_EXECUTE, TIMEOUT_ASYNC, &dwResult );

   _retl(hData);
}




