#include <WinTen.h>
#include <Windows.h>
#include <ClipApi.h>

//----------------------------------------------------------------------------//

CLIPPER ARC() // hDC, nLeftRect, nTopRect,
{
   _retl( Arc( ( HDC ) _parni( 1 ), _parni( 2 ), _parni( 3 ), _parni( 4 ),
		  _parni( 5 ), _parni( 6 ), _parni( 7 ), _parni( 8 ), _parni( 9 ) ) );
}

//----------------------------------------------------------------------------//

CLIPPER CHORD() // ( hDC, nLeftRect, nTopRect, nRightRect, nBottomRect,
                // nXStartLine, nYStartLine, nXEndLine, nYEndLine ) --> lSuccess
{
   _retl( Chord( ( HDC ) _parni( 1 ), _parni( 2 ), _parni( 3 ), _parni( 4 ),
          _parni( 5 ), _parni( 6 ), _parni( 7 ), _parni( 8 ), _parni( 9 ) ) );
}

//----------------------------------------------------------------------------//

CLIPPER LINETO()
{
   HPEN hOldPen = _parni( 4 ) ? SelectObject( ( HDC ) _parni( 1 ),
                                              _parni( 4 ) ): 0;
   BOOL bResult = LineTo( ( HDC ) _parni( 1 ), _parni( 2 ), _parni( 3 ) );

   if( hOldPen )
      SelectObject( ( HDC ) _parni( 1 ), hOldPen );

   _retl( bResult );
}

//----------------------------------------------------------------------------//

CLIPPER FLOODFILL() // hDC, nCol, nRow, nRGBColor  --> lSuccess
{
   _retl( FloodFill( _parni( 1 ), _parni( 2 ), _parni( 3 ), _parnl( 4 ) ) );
}

//----------------------------------------------------------------------------//

CLIPPER POLYPOLYGO() // N( hDC, aPoligon1, ..., aPoligonN ) --> lSuccess
{
   HDC hDC = ( HDC ) _parni( 1 );
   WORD wArray, wVertex, wItem = 0, wLen = 0;
   POINT * pBuffer;
   WORD * pItems;
   WORD wPolygons = PCOUNT() - 1;

   pItems = ( WORD * ) _xgrab( ( wPolygons ) * sizeof( WORD ) );

   for( wArray = 0; wArray < wPolygons; wArray++ )
   {
      pItems[ wArray ] = _VARRAYLEN( _param( wArray + 2, -1 ) );
      wLen += pItems[ wArray ];
   }

   pBuffer = ( POINT * ) _xgrab( wLen * sizeof( POINT ) );

   for( wArray = 0; wArray < wPolygons; wArray++ )
   {
     for( wVertex = 0; wVertex < pItems[ wArray ]; wVertex++ )
     {
        _cAt( _param( wArray + 2, -1 ), wVertex + 1, -1, _eval );
        pBuffer[ wItem   ].x = _parni( -1, 1 );
        pBuffer[ wItem++ ].y = _parni( -1, 2 );
     }
   }

   _retl( PolyPolygon( hDC, pBuffer, ( int * ) pItems, wPolygons ) );
   _xfree( ( void * ) pBuffer );
   _xfree( ( void * ) pItems );
}

//----------------------------------------------------------------------------//

CLIPPER SETPOLYFIL() // LMODE( hDC, nMode ) --> nPrevMode
{
   _retni( SetPolyFillMode( ( HDC ) _parni( 1 ), _parni( 2 ) ) );
}

//----------------------------------------------------------------------------//

CLIPPER RECTANGLE()
{
   HPEN hOldPen = _parni( 6 ) ? SelectObject( _parni( 1 ), _parni( 6 ) ): 0;
   BOOL bResult = Rectangle( _parni( 1 ),      // hDC
                             _parni( 3 ),      // nRow
                             _parni( 2 ),      // nCol
                             _parni( 5 ),      // nBottom
                             _parni( 4 ) );  // nRight
    if( hOldPen )
       SelectObject( _parni( 1 ), hOldPen );

    _retl( bResult );
}

//----------------------------------------------------------------------------//

CLIPPER PIE()
{
   _retl( Pie( _parni( 1 ),            // hDC
               _parni( 3 ),            // nLeftRect
               _parni( 2 ),            // nTopRect
               _parni( 5 ),            // nRightRect
               _parni( 4 ),            // nBottomRect
               _parni( 7 ),            // nStartCol
               _parni( 6 ),            // nStartRow
               _parni( 9 ),            // nEndCol
               _parni( 8 ) ) );        // nEndRow
}

//----------------------------------------------------------------------------//
