#include <WinTen.h>
#include <Windows.h>
#include <Print.h>
#include <CommDlg.h>
#include <ClipApi.h>

#define PORTRAIT              1
#define LANDSCAPE             2
#define SETCOPYCOUNT         17
#define GETSETPAPERORIENT    30
#define GETPRINTINGOFFSET    13

static far PRINTDLG pd;
static far BOOL bInit = FALSE;

//----------------------------------------------------------------------------//

static void PrinterInit( void )
{
   if( ! bInit )
   {
      bInit = TRUE;
      _bset( ( BYTE * ) &pd, 0, sizeof( PRINTDLG ) );
      pd.lStructSize = sizeof( PRINTDLG );
      pd.Flags       = PD_RETURNDEFAULT | PD_USEDEVMODECOPIES;
      PrintDlg( &pd );
   }
}

//----------------------------------------------------------------------------//

CLIPPER GetPrintDC() // ( hWndOwner ) --> hDC
{
   PrinterInit();

   pd.hwndOwner = _parni( 1 );
   pd.Flags     = PD_RETURNDC | PD_USEDEVMODECOPIES;

   _retni( PrintDlg( &pd ) ? pd.hDC: 0 );
}

//----------------------------------------------------------------------------//

CLIPPER PRINTERSET() // up( hWndOwner ) --> nil
{
   PrinterInit();

   pd.hwndOwner = IF( PCOUNT() == 0, GetActiveWindow(), _parni( 1 ) );
   pd.Flags     = PD_PRINTSETUP | PD_USEDEVMODECOPIES;

   PrintDlg( &pd );
}

//----------------------------------------------------------------------------//

CLIPPER StartDOC()
{
   DOCINFO info;

   info.cbSize      = sizeof( DOCINFO );
   info.lpszDocName = _parc( 2 );
   info.lpszOutput  = _parc( 3 );

   _retni( StartDoc( _parni( 1 ),       // hDC printer device
                     &info ) );
}

//----------------------------------------------------------------------------//

CLIPPER EndDOC()
{
   _retni( EndDoc( _parni( 1 ) ) );     // hDC printer device
}

//----------------------------------------------------------------------------//

CLIPPER StartPAGE()
{
   _retni( StartPage( _parni( 1 ) ) );  // hDC printer device
}

//----------------------------------------------------------------------------//

CLIPPER EndPAGE()
{
   _retni( EndPage( _parni( 1 ) ) );    // hDC printer device
}

//----------------------------------------------------------------------------//

CLIPPER PRNLANDSCA() // PE()  --> lSuccess
{
   LPDEVMODE  lpDevMode;

   PrinterInit();

   lpDevMode  = (LPDEVMODE) GlobalLock( pd.hDevMode );

   lpDevMode->dmOrientation = DMORIENT_LANDSCAPE;

   GlobalUnlock( pd.hDevMode );

   _retl( TRUE );
}

//----------------------------------------------------------------------------//

CLIPPER PRNPORTRAI() // T()  --> lSuccess
{
   LPDEVMODE  lpDevMode;

   PrinterInit();

   lpDevMode  = (LPDEVMODE) GlobalLock( pd.hDevMode );

   lpDevMode->dmOrientation = DMORIENT_PORTRAIT;

   GlobalUnlock( pd.hDevMode );

   _retl( TRUE );
}

//----------------------------------------------------------------------------//

CLIPPER PRNSETCOPI() // ES( nCopies )  --> lSuccess
{
   LPDEVMODE lpDevMode;

   PrinterInit();

   lpDevMode = (LPDEVMODE) GlobalLock( pd.hDevMode );

   lpDevMode->dmCopies = _parni( 1 );

   if( PCOUNT() == 2 )  // Compatibility with previous syntax!
      lpDevMode->dmCopies = _parni( 2 );

   GlobalUnlock( pd.hDevMode );

   _retl( TRUE );
}

//----------------------------------------------------------------------------//

CLIPPER ESCAPE() // ( hDC, nEscape, cInput, @cOutPut ) --> nReturn
{
   BYTE * pBuffer = IF( PCOUNT() == 4, _xgrab( _parclen( 3 ) ), 0 );

   _retni( Escape( _parni( 1 ), _parni( 2 ), _parclen( 3 ), _parc( 3 ),
                   pBuffer ) );

   if( pBuffer )
   {
      _storclen( pBuffer, _parclen( 3 ), 4 );
      _xfree( pBuffer );
   }
}

//----------------------------------------------------------------------------//

CLIPPER GETPRINTDE() // FAULT( hWndOwner ) --> nil
{
   LPDEVNAMES lpDevNames;
   LPDEVMODE  lpDevMode;

   PrinterInit();

   lpDevNames = (LPDEVNAMES) GlobalLock( pd.hDevNames );
   lpDevMode  = (LPDEVMODE) GlobalLock( pd.hDevMode );

   _retni( CreateDC( ( LPSTR ) lpDevNames + lpDevNames->wDriverOffset,
                     ( LPSTR ) lpDevNames + lpDevNames->wDeviceOffset,
                     ( LPSTR ) lpDevNames + lpDevNames->wOutputOffset,
                     lpDevMode ) );

   GlobalUnlock( pd.hDevNames );
   GlobalUnlock( pd.hDevMode );
}

//----------------------------------------------------------------------------//

CLIPPER PRNOFFSET() // ( hDC)  --> aPoint
{
   POINT pt;

   pt.y = 0;
   pt.x = 0;

   Escape( ( HDC ) _parni( 1 ),
           GETPRINTINGOFFSET,
           NULL, NULL, ( LPPOINT ) &pt ) ;

   _reta( 2 );
   _storni( pt.y, -1, 2 );
   _storni( pt.x, -1, 1 );
}

//----------------------------------------------------------------------------//

CLIPPER RESETDC() // hDC --> lSuccess
{
   LPDEVMODE  lpDevMode;

   PrinterInit();

   lpDevMode = ( LPDEVMODE ) GlobalLock( pd.hDevMode );

   // _retl( ResetDC( _parni( 1 ), lpDevMode ) );

   GlobalUnlock( pd.hDevMode );
}

//----------------------------------------------------------------------------//
