#include <WinTen.h>
#include <Windows.h>
#include <ClipApi.h>

extern HANDLE __hInstance;

extern void   _fwFreeLibrary( LPSTR pLibName );
extern HANDLE _fwLoadLibrary( LPSTR pLibName );
extern void   _fwFreeAllLibrarys( void );

static HANDLE hResources = 0;

//----------------------------------------------------------------------------//

CLIPPER SETRESOURC()   // ES()
{
   if( ISCHAR( 1 ) )
       hResources = _fwLoadLibrary( _parc( 1 ) );
   else if( ISNUM( 1 ) )
       hResources = _parni( 1 );

   _retni( hResources );
}

//----------------------------------------------------------------------------//

HANDLE GetResources( void )
{
   return IF( hResources, hResources, __hInstance );
}

//----------------------------------------------------------------------------//

CLIPPER GETRESOURC()   // ES()
{
   _retni( GetResources() );
}

//----------------------------------------------------------------------------//

CLIPPER FreeResour()
{
   _fwFreeAllLibrarys();
   if( hResources )
       hResources = 0;
}

//----------------------------------------------------------------------------//

CLIPPER FINDRESOUR() // ( hResources, cResourceName, nResType )
{
    _retni( FindResource( _parni( 1 ), _parc( 2 ), MAKEINTRESOURCE( _parni( 3 ) ) ) );
}

//---------------------------------------------------------------------------//

CLIPPER RESOURCEFR() // EE()   hResource
{
   FreeResource( _parni( 1 ) );
}

//---------------------------------------------------------------------------//

CLIPPER LOADRESOUR() // CE()       hResource, hFindResource
{
   _retni( LoadResource( _parni( 1 ), _parni( 2 ) ) );
}

//---------------------------------------------------------------------------//

CLIPPER GETFREESYS() // TEMRESOURCES( nType ) --> nPercentage
{
   _retni( GetFreeSystemResources( _parni( 1 ) ) );
}

//---------------------------------------------------------------------------//

CLIPPER HASRESOURC() // ES( cExeName ) --> lHasResources
{
   WORD hFile         = _topen( _parc( 1 ), 0 );
   WORD wIsNewExe     = 0;
   WORD wPtrHeader    = 0;
   WORD wPtrResources = 0;
   WORD wType         = 0;

   if( hFile )
   {
      _tlseek( hFile, 0x18, 0 );   // NE indication
      _tread( hFile, ( LPBYTE ) &wIsNewExe, 2 );

      if( wIsNewExe < 0x40 )
      {
         MessageBox( GetActiveWindow(), "This is not a Windows file!",
                     "Atention", MB_ICONSTOP );
         _tclose( hFile );
         return;
      }

      _tlseek( hFile, 0x3C, 0 );   // Pointer to header info
      _tread( hFile, ( LPBYTE ) &wPtrHeader, 2 );
      _tlseek( hFile, wPtrHeader + 0x24, 0 );  // Resources offset
      _tread( hFile, ( LPBYTE ) &wPtrResources, 2 );

      if( ! wPtrResources )
      {
         MessageBox( GetActiveWindow(), "No resources in this file!",
                     "Atention", MB_ICONSTOP );
         _tclose( hFile );
         return;
      }
      _tlseek( hFile, wPtrHeader + wPtrResources + 0x2, 0 );
      _tread( hFile, ( LPBYTE ) &wType, 2 );

      _retnl( wType );
      _tclose( hFile );
   }
   else
      _retl( 0 );
}

//---------------------------------------------------------------------------//
